<?php
//!-- courses --
$db = new PDO('sqlite:db/database.sqlite');

function courses() {
    global $db;

    $statement = $db->query("SELECT * FROM courses");
    return $statement->fetchall();
}
//!-- end courses --

//!-- set_value --
function set_value($name){
    return filter_input(
        INPUT_POST,
        $name,
        FILTER_SANITIZE_SPECIAL_CHARS,
        ['options' => ['default' => '']]);
}
//!-- end set_value --

//!-- compute_error --
function compute_error($form_data,$filters){
    foreach($filters as $key => $filter){
        $data = &$form_data[$key];
        if (
            $data===null ||
            (is_array($data)&&in_array(null,$data,true))
        ){
            return $filter['message'];
        }
    }
    return false;
}
//!-- end compute_error --

//!-- register --
function register($firstname,$lastname,$courses) {
    global $db;
    
    $db->beginTransaction();
    $query1='INSERT INTO students(firstname, lastname) VALUES (?, ?)';
    $statement = $db->prepare($query1);
    $success = $statement->execute([$firstname, $lastname]);
    if (!$success) {
        $db->rollback();
        return false;
    }
    $student_id = $db->lastInsertId();

    $query='INSERT INTO choices(student_id, course_id) VALUES (?, ?)';
    $statement = $db->prepare($query);
    foreach ($courses as $course_id) {
        $success = $statement->execute([$student_id, $course_id]);
        if (!$success) {
            $db->rollback();
            return false;
        }
    }
    $db->commit();
    return true;    
}
//!-- end register --

//!-- registrations --
function registrations() {
    global $db;
    $query = "SELECT students.firstname,students.lastname,"
           ."group_concat(courses.name, ', ') "
           ."as courses "
           ."FROM students "
           ."LEFT JOIN choices ON students.id = choices.student_id "
           ."LEFT JOIN courses ON choices.course_id = courses.id "
           ."GROUP BY students.id";
    $statement = $db->query("$query");
    
    return $statement->fetchall();
}
//!-- end registrations --

