PRAGMA foreign_keys = ON;
DROP TABLE IF EXISTS choices;
DROP TABLE IF EXISTS courses;
DROP TABLE IF EXISTS students;

CREATE TABLE courses(
       id INTEGER PRIMARY KEY AUTOINCREMENT,
       name TEXT
);

CREATE TABLE students (
       id INTEGER PRIMARY KEY AUTOINCREMENT,
       firstname TEXT,
       lastname TEXT
);

CREATE TABLE choices (
       student_id INTEGER,
       course_id INTEGER,
       UNIQUE(student_id, course_id),
       FOREIGN KEY(student_id)
       	       REFERENCES students(id) ON DELETE CASCADE,
       FOREIGN KEY(course_id)
       	       REFERENCES courses(id) ON DELETE CASCADE
);

INSERT INTO courses(name) VALUES ('Java');
INSERT INTO courses(name) VALUES ('PHP');
INSERT INTO courses(name) VALUES ('C');

